var EventName = raisedEvent.name;
// debug("INFO_1", "EventName:" + EventName);

if (EventName == "model_ready") {
	Property.load();
	WescoVars.initialize();
	tiny.writingDone();
	WescoVars.save("Controller/PresenceState_previous", "Schedule", true); //set previous mode in presence to Schedule"

	var timer = timedevents.timers["TIMER_discoverAirboxes"];
	var parameter = {};
	timedevents.call(timer.name, timer.id, timer.duration, parameter);

	exhood.discover(); // discovered ExHood
	airboxes.discover(); // discover airboxes
	wcfans.discover(); //discover wc ventilators


	try {
		cloudService.fetchNotificationList(notifications.createList);
	} catch (err) {
		// report error,  no cloud activated
	}
	// starts timer for evaluation of ventilation schedules. Every hour, at XX:01
	var timerBoost = timedevents.timers["TIMER_ventilationSchedule"];
	timedevents.callPeriodic(timerBoost.name, timerBoost.id, "FREQ=HOURLY;BYMINUTE=01");
	//timedevents.callPeriodic(timerBoost.name,timerBoost.id,"FREQ=MINUTELY");
	//
} else {
	var BigMode = WescoVars.get("Controller/BigModeState_current");
	var parameter = raisedEvent.parameter;

	/*******************************************************************/
	/*************************** FSM BigMode ***************************/
	/*******************************************************************/

	switch (BigMode) {
		case "Alarm":
			if (EventName == "wesco_stateChange") {
				var statename = parameter.statename;
				var state = parameter.state;

				if (statename == "fire" && state == "inactive") {
					var previousState = WescoVars.get("Controller/BigModeState_previous");
					WescoVars.save("Controller/BigModeState_current", previousState, true); // switch to previous

					// before leaving the mode fire, reenable all
					// FSM. This is in case a lock was active before
					// entering the alarm state.
					tiny.writingDone();
					airboxes.unlockAllAirboxes();
				}
			}
			break;
		case "Presence":
			var PresenceMode = WescoVars.get("Controller/PresenceState_current");
			switch (EventName) {

				case "wesco_processedScene": // Absence mode exit condition

					var Scene = parameter["sceneID"];
					var groupID = parameter["groupID"];

					if (groupID == 0 && Scene == 76) { // If the FIRE scene is triggered
						WescoVars.save("Controller/BigModeState_current", "Alarm", false); // switch to Alarm Mode
						WescoVars.save("Controller/BigModeState_previous", "Presence", true);
						turnEverythingOFF();
					} else if (groupID == 0 && Scene == 72) { // if the "leave home" scene is called
						WescoVars.save("Controller/BigModeState_current", "Absence", false); // switch to Absence Mode
						WescoVars.save("Controller/BigModeState_previous", "Presence", true);
						//process scene () -> evaluate control rules
					} else if (groupID == 10) { // Include taster scenes
						debug("INFO_2", "Received scene from group:" + groupID + ";scene:" + Scene);
					}
					break;
			} //end switch(raisedEvent.name){

			break;
		case "Absence":
			switch (EventName) {
				case "wesco_processedScene": // Absence mode exit condition
					var Scene = parameter["sceneID"];
					var groupID = parameter["groupID"];

					if (Scene == 76) { // If the FIRE scene is triggered
						WescoVars.save("Controller/BigModeState_current", "Alarm", false); // switch to Alarm Mode
						WescoVars.save("Controller/BigModeState_previous", "Absence", true);
						turnEverythingOFF();
					} else if (Scene == 71 || (groupID == 10 )) {
						// if the "come home" scene is called or any scene in
						WescoVars.save("Controller/BigModeState_current", "Presence", false); // switch to Presence Mode
						WescoVars.save("Controller/BigModeState_previous", "Absence", true);

						//process scene () -> evaluate control rules
					}

					// Include taster scenes
					break;

			} //end switch(raisedEvent.name){


			break;
		default:
			break;
	}
}
/*******************************************************************/
/*******************  End of FSM BigMode ***************************/
/*******************************************************************/



var BigMode_current = WescoVars.get("Controller/BigModeState_current");
debug("INFO_2", "BigMode:" + BigMode_current);
debug("INFO_2", "event;" + raisedEvent.name);


if (BigMode_current == "Absence" || BigMode_current == "Presence") {
	switch (EventName) {
		/*************************************************************/
		/*************************************************************/
		/********* Events affecting the ventilation balance **********/
		/*************************************************************/
		/*************************************************************/

		case timedevents.timers["TIMER_ventilationSchedule"].name:
			var PresenceMode = WescoVars.get("Controller/PresenceState_current");

			if (BigMode_current == "Absence") {
				var level = processSchedule("Absence"); // Absence Schedule
				control.processRules("TimePlan", level);

			} else if (BigMode_current == "Presence") {
				var level = processSchedule("Presence"); // Presence Schedule
				control.processRules("TimePlan", level);
			}

			// if (level!==undefined) { ...
			// Evaluate the control rules

			debug("INFO_3", "Boost:" + BigMode_current + ";level:" + level);
			break;

		case "wesco_processedScene": // Absence mode exit condition
			var Scene = parameter["sceneID"];
			var groupID = parameter["groupID"];


			if (groupID == 10) { // || ((ClusterID!==undefined && ClusterID!== null) || groupID==ClusterID)){
				//control.processRules("Scene",Scene);

				// update mode if necessary
				if (BigMode_current != "Presence") {
					WescoVars.save("Controller/BigModeState_current", "Presence", true); // switch to previous
				}
			}

			break;

		case "wesco_UIVentilationLevelEvent":
			var uilevel = parseInt(parameter["level"]);

			debug("INFO_1", "UI-Level:" + uilevel);

			control.processRules("UIEvent", uilevel);

			break;
		case "wesco-wcfan-state-change-event": // Absence mode exit condition
			var dsuid = raisedEvent.parameter.dsuid;
			var state = raisedEvent.parameter.state;
			debug("INFO_1", "Received wesco-wcfan-state-change event: dsuid:" + dsuid + ";state:" + state);
			wcfans.setWCStatus(dsuid, state);

			control.processRules("WCFan", 0); // value is not

			break;

		case timedevents.timers["TIMER_reevaluateBalanceRules"].name:
			control.processRules("ReevaluateRules", 0); // value is not
			break;

		case timedevents.timers["TIMER_deactivateManualMode"].name:
			control.processRules("DeactivateManualMode", 0); // value is not
			break;

		case "deviceStatusEvent":
			// asynchronous message from the airbox or the extraction hood
			// This message can be used for error notifications

			var dsuid = raisedEvent.source['dsuid'];
			var AirboxPath = "Airboxes/Devices/" + dsuid;
			var ExHoodPath = "ExHood/Devices/" + dsuid;

			//TODO: Add WC fans

			if (exhood.isExHood(dsuid)) {
				if (BigMode_current != "Presence") {
					WescoVars.save("Controller/BigModeState_current", "Presence", true); // switch to previous
				}

				debug("INFO_1", "Event coming from Exhood:" + dsuid + "");
				try {
					var statusIndex = raisedEvent.parameter.statusIndex;
					var statusValue = parseInt(raisedEvent.parameter.statusValue);

					debug("INFO_2", "statusIndex:" + statusIndex + ";statusValue:" + statusValue);

					var Type = WescoVars.get(ExHoodPath + "/Type", false);
					if (Type == 'Fan_Flap') {
						//status=(fan <<8) | flap
						var flap = statusValue & 0xFF;
						var fan = (statusValue >> 8) & 0xFF;

						if (flap >= 0 && flap <= 100 && statusIndex != DS_POLL_STATUS_INFO) { //store the value to be visualized but don't modify the control
							WescoVars.save(ExHoodPath + "/CurrentValue_flap", flap, true);
							WescoVars.save("Controller/ExhoodCurrentValue_flap", flap, false);

							debug("INFO_3", "Configured Flap:" + flap);
						}

						if (fan >= 0 && fan <= 100) {
							WescoVars.save(ExHoodPath + "/CurrentValue_fan", fan, false);
							WescoVars.save("Controller/ExhoodCurrentValue_fan", fan, false);
							debug("INFO_3", "Configured Fan:" + fan);

							if (statusIndex == DS_POLL_STATUS_INFO) { // modify the control only if statusIndex==25
								control.processRules("CookingMode", fan) // pass fan value
							}

						}
					} else if (Type == 'Window') {
						if (statusValue > 0) {
							WescoVars.save(ExHoodPath + "/Status", 1, true);
							debug("INFO_2", "Configured Window Contact:" + statusValue + "Status: 1");
						} else {
							WescoVars.save(ExHoodPath + "/Status", 0, true);
							debug("INFO_2", "Configured Window Contact:" + statusValue + "Status: 0");
						}
					}
				} catch (err) {
					// report error,  no cloud activated
				}


			} else if (airboxes.isAirbox(dsuid)) { // check if the source is an airbox
				// The error flag is set at the removeError state machine when
				// an error is reported.  This flag can only be cleared up from
				// the UI.
				var errorCode = WescoVars.get_create(AirboxPath + "/errorCode", 'None', false);
				var errorFSMState = WescoVars.get_create(AirboxPath + "/errorFSMState", "ready", true);
				var statusIndex = raisedEvent.parameter.statusIndex;
				var statusValue = raisedEvent.parameter.statusValue;


				if (statusIndex == AIRBOX_STATUS_EVENT_INDEX) {
					if (statusValue & 0x01) {
						airboxes.setStatus(dsuid, 0x01); // bit wise_active
						debug("INFO_2", "Airbox locked (unavailable for ventilation)");
					} else {
						airboxes.clearStatus(dsuid, 0x01);
						debug("INFO_2", "Airbox unlocked (available for ventilation)");
					}

					if (statusValue & 0x80) { //initialization event
						var AirboxID = raisedEvent.source['dsid'];
						var PropTreeReady = WescoVars.get("Controller/PropTreeReady");

						//airboxes.clearStatus(dsuid,0x01);
						//airboxes.clearStatus(dsuid,0x40);

						if (PropTreeReady == "Ready") {
							// Verify first that the device is not in the error state.
							//airboxes.callLastScene(AirboxID);
						}
					}
				} else if (statusIndex == AIRBOX_ERROR_EVENT_STATUS_INDEX) {
					if (statusValue & 0x80) {
						if (errorCode === undefined || errorCode == ErrorCodes["no_error"]) {
							// Call the airbox error routine
							airboxes.removeError(dsuid, parseInt(statusValue) & ~0x40, "errorEvent");
						}
					}
					if (statusValue & 0x40) { // warning, one ventilator fails
						airboxes.setStatus(dsuid, 0x40); // bit wise_active
						debug("INFO_2", "One fan is defect");
					} else {
						airboxes.clearStatus(dsuid, 0x40);
					}
				} //end ... else if (statusIndex==AIRBOX_ERROR_EVENT_STATUS_INDEX){
			} // end ...if (airboxes.isAirbox(dsuid)){ // check if the source is an airbox

			// if statusIndex == 25
			//   airboxes.setStatus(dsuid,"LOCKED"); oder
			//   airboxes.setStatus(dsuid,"NORMAL"); oder

			break;

			/*************************************************************/
			/*************************************************************/
			/********* Events not affecting the AIR balance **************/
			/*************************************************************/
			/*************************************************************/

		case timedevents.timers["TIMER_discoverAirboxes"].name:
			var timerparameter = {};
			timer = timedevents.timers["TIMER_checkFilterReplacement"];
			timedevents.call(timer.name, timer.id, timer.duration, timerparameter);

			wcfans.confSceneResponderAllWCFans(); // CHECK

			readAirboxesConf(); // this info is required for processing the control rules
			//sendAirboxSceneDeferred(AirboxScenes[0],"+100");
			// wait 100s and then start the airboxes (scene,wait time in seconds)
			WescoVars.save("Controller/PropTreeReady", "Ready", false); // mark the app as ready
			break;


		case timedevents.timers["TIMER_defer_DS_Action"].name:
			{
				/*This mechanism doesn't implement a queue, only the last
				 * called command is executed. It the flag is busy and a new
				 * command arrives, this command is rescheduled for later
				 * execution. If while waiting, another command arrives, the
				 * former command is replaced by the latter*/

				var param = raisedEvent.parameter;
				var busy = WescoVars.get_create("Controller/writingInProgress", false, false);
				if (busy == false) {
					tiny.SendMultiple(param); // complete the deferred action
				} else if (busy == true) { // relaunch the timer, continues waiting until busy is false
					timer = timedevents.timers["TIMER_defer_DS_Action"];
					timedevents.call(timer.name, timer.id, timer.duration, param);
				}
				break;
			}

		case timedevents.timers["TIMER_remove_busy_flag"].name:
			/*Timeout for resetting writingInProgress Flag*/
			debug("INFO_3", "Remove BusyFlag");
			tiny.writingDone();
			break;


		case "wesco_UI":
			parseUICommand(raisedEvent.parameter);
			break;

		case "wesco_RegistersOpCompleted":
			// This event is raised after a reading operation has been completed.

			// The UI can also subscribe to this event
			var args = JSON.parse(raisedEvent.parameter.Regs);
			var Path = raisedEvent.parameter.path_toDevices;

			for (var i in args) {
				var Reg = args[i];
				if (Reg.length == 2) { //if it was a writing operation
					var Value = parseInt(Reg[1]);
					var RegNum = parseInt(Reg[0]);
					exhood.updateVariables(Path, RegNum, Value);
					airboxes.updateVariables(Path, RegNum, Value);
				}
			}


			//for airboxes only: to get the error and software version
			if (Path.indexOf("Airboxes") >= 0) {
				var Dict = JSON.parse(raisedEvent.parameter.Dict);
				for (var i in args) {
					var Reg = args[i];
					for (var Dev in Dict) {
						var Path = Dict[String(Dev)].Path;
						var completed = Dict[String(Dev)].completed;
						var Value = parseInt(completed[i]);
						airboxes.updateVariables(Path, Reg, Value);
					}
				}
			}
			tiny.writingDone();
			break;

		case timedevents.timers["TIMER_MultipleRegAction_FSM"].name:
			debug("INFO_3", "event;MultipleRegAction_FSM_Timer");
			var parameter = raisedEvent.parameter;
			tiny.SendMultiple(parameter); // relaunch the airbox writing FSM
			break;

		case timedevents.timers["TIMER_clearupAirboxError"].name:
			var parameter = raisedEvent.parameter;
			var dsuid = parameter['dsuid'];
			airboxes.removeError(dsuid, 0, "Timer");
			break;


		case timedevents.timers["TIMER_sendPushNotification"].name:
			var parameter = raisedEvent.parameter;
			var Type = parameter['Type'];
			notifications.push(Type);
			break;


		case timedevents.timers["TIMER_checkFilterReplacement"].name:
			try {
				cloudService.fetchNotificationList(notifications.createList);
			} catch (err) {
				// report error,  no cloud activated
			}
			if (airboxes.checkFilterReplacement()) {
				//notifications.schedule("FilterReplacement");
				//notifications.sendEmailFilterReplacement();
			}

			// set the timer to verify the filter replacement next time
			var timer = timedevents.timers["TIMER_checkFilterReplacement"];
			var parameter = {};
			timedevents.call(timer.name, timer.id, timer.duration, parameter);
			airboxes.discover();
			break;



		default:
			break;
	} // end ... switch(raisedEvent.name){
} // end ...if(BigMode=="Absence" || BigMode=="Presence"){
else if (BigMode == "Alarm") {
	switch (EventName) {
		case timedevents.timers["TIMER_defer_DS_Action"].name:
			{
				/*This mechanism doesn't implement a queue, only the last
				 * called command is executed. It the flag is busy and a new
				 * command arrives, this command is rescheduled for later
				 * execution. If while waiting, another command arrives, the
				 * former command is replaced by the latter*/

				var param = raisedEvent.parameter;
				var busy = WescoVars.get_create("Controller/writingInProgress", false, false);
				if (busy == false) {
					tiny.SendMultiple(param); // complete the deferred action
				} else if (busy == true) { // relaunch the timer, continues waiting until busy is false
					timer = timedevents.timers["TIMER_defer_DS_Action"];
					timedevents.call(timer.name, timer.id, timer.duration, param);
				}
				break;
			}

		case timedevents.timers["TIMER_MultipleRegAction_FSM"].name:
			{
				debug("INFO_3", "event;MultipleRegAction_FSM_Timer");
				var parameter = raisedEvent.parameter;
				tiny.SendMultiple(parameter); // relaunch the airbox writing FSM
				break;
			}

	}
}


/********************************************************************************/
/********************************************************************************/
/*************  General functions definiton *************************************/
/********************************************************************************/
/********************************************************************************/

function sendAirboxSceneDeferred(SceneNum, waitTime) {
	var parameter = {};
	var Dict = {};
	var scenen = [SceneNum];
	parameter['action'] = 'sendScene';
	parameter['path_toDevices'] = 'Airboxes/Devices';
	parameter['args'] = JSON.stringify(scenen);
	parameter['FSMState'] = "initialize";
	parameter['Dict'] = JSON.stringify(Dict);

	var timer = timedevents.timers["TIMER_defer_DS_Action"];
	timedevents.call(timer.name, timer.id + "_initialization", waitTime, parameter);
}

function sendAirboxScene(SceneNum) {
	var parameter = {};
	var Dict = {};
	var scenen = [SceneNum];
	parameter['action'] = 'sendScene';
	parameter['path_toDevices'] = 'Airboxes/Devices';
	parameter['args'] = JSON.stringify(scenen);
	parameter['FSMState'] = "initialize";
	parameter['Dict'] = JSON.stringify(Dict);

	tiny.SendMultiple(parameter);
}

function turnEverythingOFF() {
	// turns the exhaust hood and the airboxes off
	debug("INFO_1", "turning everything off");
	var ExHood_dSID = exhood.getFanFlap_dSID();
	tiny.Scene(ExHood_dSID, 0); //turn exhaust hood off
	sendAirboxSceneDeferred(0, "+5"); // send scene to all airboxes in 5 seconds time.
}

function readAirboxesConf() {
	/*Starts an operation reading registers 0 (error), 13-15 (level
	 * 1-3) in all airboxes*/
	var parameter = {};
	var Dict = {};
	parameter['action'] = 'readAll';
	parameter['path_toDevices'] = 'Airboxes/Devices/';

	// Read the following Airbox registers
	// 0 -> status
	// 62 -> Software version

	// The returned values are handled in the updateVariables function
	// in the airbox module after the wesco_RegistersOpCompleted is
	// received

	parameter['args'] = JSON.stringify([0, 62]); // 0-> error, 62->software version
	parameter['FSMState'] = "initialize";
	parameter['Dict'] = JSON.stringify(Dict);
	tiny.SendMultiple(parameter);
}

function readExHoodFlapConf() {
	var parameter = {};
	var Dict = {};
	parameter['action'] = 'readSingle';
	parameter['dSID'] = exhood.getFanFlap_dSID();
	parameter['path_toDevices'] = 'ExHood/Devices/';


	parameter['args'] = JSON.stringify([26, 27, 28, 29, 30, 31, 32, 33, 34, 35]); // read flap % values
	parameter['FSMState'] = "initialize";
	parameter['Dict'] = JSON.stringify(Dict);
	tiny.SendMultiple(parameter);

	// values are returned within the wesco_RegistersOpCompleted event
}

function processSchedule(mode) { // Zeitplan Evaluation
	// Returns a level low-full

	var d = new Date();
	var day = d.getDay(); // 0: Sunday ... 6: Saturday
	var hour = parseInt(d.getHours()); // 0 ... 23

	var schedule = WescoVars.get("Controller/VentilationSchedule/" + day);
	var ret = undefined;

	if (schedule !== undefined && schedule !== null) { // if there is an entrance for that particular day
		schedule = JSON.parse(schedule);
		for (var i in schedule) {
			var from = parseInt(schedule[i].from);
			var until = parseInt(schedule[i].until);
			if (hour >= from && hour < until) {
				if (mode == 'Presence') {
					ret = schedule[i].Presence;
				} else if (mode == 'Absence') {
					ret = schedule[i].Absence;
				}
			}
		}
	} else if (day >= 1 && day <= 5) { // if a weekday (1: Monday, 5: Friday)
		schedule = WescoVars.get("Controller/VentilationSchedule/7"); // weekday
		if (schedule !== undefined && schedule !== null) {
			schedule = JSON.parse(schedule);
			for (var i in schedule) {
				var from = parseInt(schedule[i].from);
				var until = parseInt(schedule[i].until);
				if (hour >= from && hour < until) {
					if (mode == 'Presence') {
						ret = schedule[i].Presence;
					} else if (mode == 'Absence') {
						ret = schedule[i].Absence;
					}
				}
			}
		}
	} else if (day == 0 || day == 6) { // if a weekend (0: Sunday, 6: Saturday)
		schedule = WescoVars.get("Controller/VentilationSchedule/8"); //weekend
		if (schedule !== undefined && schedule !== null) {
			schedule = JSON.parse(schedule);
			for (var i in schedule) {
				var from = parseInt(schedule[i].from);
				var until = parseInt(schedule[i].until);
				if (hour >= from && hour < until) {
					if (mode == 'Presence') {
						ret = schedule[i].Presence;
					} else if (mode == 'Absence') {
						ret = schedule[i].Absence;
					}
				}
			}
		}
	} // end if (day==0 || day==6){ // if a weekend{

	return ret;
}