var airboxApp = angular.module('airbox', ['ui.bootstrap', 'dSTinyDSS', 'airboxControllers', 'gettext', 'ngRoute', 'angular-confirm']);


airboxApp.filter('trustAsHtml', function($sce) {
	return function(html) {
		return $sce.trustAsHtml(html);
	};
});

airboxApp.config(['$routeProvider', '$httpProvider', function($routeProvider, $httpProvider) {
	$routeProvider
		.when('/', {
			templateUrl: 'partials/control.html',
			controller: 'OverviewCtrl',
			routeName: 'overview'
		})
		.when('/app_conf', {
			templateUrl: 'partials/app_conf.html',
			controller: 'OverviewCtrl',
			routeName: 'app_conf'
		})
		.when('/app_advanced_conf', {
			templateUrl: 'partials/app_advanced_conf.html',
			controller: 'AirboxConfCtrl',
			routeName: 'app_advanced_conf'
		})
		.when('/airbox_conf', {
			templateUrl: 'partials/airbox_conf.html',
			controller: 'AirboxConfCtrl',
			routeName: 'airbox_conf'
		})
		.when('/base_vent_conf', {
			templateUrl: 'partials/base_ventilation.html',
			controller: 'OverviewCtrl',
			routeName: 'base_vent_conf',
		})
		.when('/exhood_conf', {
			templateUrl: 'partials/exhood_conf.html',
			controller: 'AirboxConfCtrl',
			routeName: 'exhood_conf'
		})

	.when('/wcfans_conf', {
		templateUrl: 'partials/wcfans_conf.html',
		controller: 'AirboxConfCtrl',
		routeName: 'wcfans_conf'
	})


	.otherwise({
		redirectTo: '/'
	});

	// added by Jonas. Required to authenticate the app and be able to send JSON commands
	$httpProvider.defaults.xsrfCookieName = 'csrf-token';
	$httpProvider.defaults.xsrfHeaderName = 'X-Csrf-Token';

}]);