function Airbox_GetVars() {
	var sceneConf = function(scene, reg, default_value) {
		var AirboxSceneConfOptions = {
			'2': "Off",
			'3': "Low",
			'4': "Medium",
			'5': "Nominal",
			'6': "Full",
			'0': "Ignore",
		};

		// return the configuration for one scene
		return {
			"id": "REG_" + reg,
			"name": "conf_scene_" + scene,
			"reg": reg,
			"type": "UINT",
			"values": AirboxSceneConfOptions,
			"unit": "",
			"default": default_value,
			"cathegory": 'D',
			"description": "Airbox's reaction to dS-Scene " + scene,
			"display_txt": "Scene " + scene,
			"help_text": ""
		};
	};
	var help_txt_operating_level = "";
	var airbox_level_description = "Air volume muss be specified under 'Air Volume Configuration'";
	var AirboxRegConf = {
		"REG_13": {
			"id": "REG_13",
			"name": "operating_state_low",
			"reg": 13,
			"level": 1, // levels are 0:off, 1:low, 2:medium, 3:nominal, 4:full
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 1,
			"cathegory": 'V',
			"display_txt": "LOW level",
			"description": airbox_level_description,
			"help_txt": help_txt_operating_level,
		},
		"REG_14": {
			"id": "REG_14",
			"name": "operating_state_medium",
			"level": 2, // levels are 0:off, 1:low, 2:medium, 3:nominal, 4:full
			"reg": 14,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 20,
			"cathegory": 'V',
			"display_txt": "MEDIUM level",
			"description": airbox_level_description,
			"help_txt": help_txt_operating_level,
		},

		"REG_15": {
			"id": "REG_15",
			"name": "operating_state_nominal",
			"reg": 15,
			"level": 3, // levels are 0:off, 1:low, 2:medium, 3:nominal, 4:full
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 39,
			"cathegory": 'V',
			"display_txt": "NOMINAL level",
			"description": airbox_level_description,
			"help_txt": help_txt_operating_level,
		},


		// "REG_16":{
		// 	"id":"REG_16",
		// 	"name":"hardware_definition",
		// 	"reg": 16,
		// 	"type":"UINT",
		// 	"min":0,
		// 	"max":255,
		// 	"step":1,
		// 	"unit":"",
		// 	"default":32,
		// 	"cathegory":'V',
		// 	"display_txt":"Hardware definition",
		// 	"description":"Temperature sensors activation (bitwise)",
		// 	"help_txt":"Bit 7: Sensor RL active; Bit 6: Sensor AL active; Bit 5: Sensor ZL acive",
		// },

		// "REG_23":{
		// 	"id":"REG_23",
		// 	"name":"maximum_power",
		// 	"reg": 23,
		// 	"type":"UINT",
		// 	"min":0,
		// 	"max":100,
		// 	"step":1,
		// 	"unit":"%",
		// 	"default":38,
		// 	"cathegory":'V',
		// 	"display_txt":"Maximum power",
		// 	"description":"",
		// 	"help_txt":"",
		// },
		// "REG_24":{
		// 	"id":"REG_24",
		// 	"name":"default_power_without_poti",
		// 	"reg": 24,
		// 	"type":"UINT",
		// 	"min":0,
		// 	"max":100,
		// 	"step":1,
		// 	"unit":"%",
		// 	"default":100,
		// 	"cathegory":'V',
		// 	"display_txt":"Default value without potenciometer",
		// 	"description":"",
		// 	"help_txt":"",
		// },
		// "REG_50":{
		// 	"id":"REG_50",
		// 	"name":"time_error_repetition",
		// 	"reg": 50,
		// 	"type":"UINT",
		// 	"min":1,
		// 	"max":255,
		// 	"step":1,
		// 	"unit":"Min",
		// 	"default":20,
		// 	"cathegory":'D',
		// 	"display_txt":"Time between error reporting",
		// 	"description":"Timer after the error is reported again",
		// 	"help_txt":"",
		// },
		// "REG_51":{
		// 	"id":"REG_51",
		// 	"name":"active_group1",
		// 	"reg": 51,
		// 	"type":"UINT",
		// 	"min":10,
		// 	"max":60,
		// 	"step":1,
		// 	"unit":"",
		// 	"default":10,
		// 	"cathegory":'D',
		// 	"display_txt":"Active group 1",
		// 	"description":"Scenes will be evaluated in this group",
		// 	"help_txt":"",
		// },

	};

	//[scene,register,default]
	var Scene = [
		[0, 25, '2'],
		[5, 26, '3'],
		[17, 27, '4'],
		[18, 28, '5'],
		[19, 29, '6'],
		//
		[34, 30, '2'],
		[23, 31, '2'],
		[24, 32, '3'],
		[25, 33, '4'],
		[35, 34, '5'],
		//
		[67, 35, '0'],
		[68, 36, '0'],
		[69, 37, '0'],
		[70, 38, '0'],
		[71, 39, '0'],
		//
		[72, 40, '0'],
		[76, 41, '2'], //Fire
		[86, 42, '0'],
		[87, 43, '0'],
		[88, 44, '0'],
		//
		[89, 45, '0'],
		[90, 46, '0'],
		[91, 47, '0']
	];

	// for (var i in Scene){ // add scene configuration to registers array
	// 	var s = Scene[i];
	// 	var Reg="REG_"+s[1];
	// 	AirboxRegConf[Reg]=sceneConf(s[0],s[1],s[2]);
	// }


	return AirboxRegConf;

	//  return {
	// 	"pages":[
	// 	    { "name":"Airbox",
	// 	      "variables":AirboxRegConf,
	// 	    },
	// 	]
	// };
}

function ExHood_GetVars() {
	var sceneConf = function(scene, reg, default_value) {
		// return the configuration for one scene
		return {
			"id": "REG_" + reg,
			"name": "conf_scene_" + scene,
			"reg": reg,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": default_value,
			"cathegory": 'D',
			"description": "ExHood's reaction to dS-Scene " + scene,
			"display_txt": "Scene " + scene,
			"help_text": ""
		};
	};

	var exhood_level_description="Exhaust hood ventilator power in level";
	var exhood_level_flap_description="Exhaust hood flap opening in level";
	var level_configuration="Configuration of level";
	var ExHoodRegConf = {
		"REG_16": {
			"id": "REG_16",
			"name": "operating_state_off",
			"reg": 16,
			"level": 0, //off 
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 0,
			"cathegory": 'Fan',
			"scene":0,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},
		"REG_17": {
			"id": "REG_17",
			"name": "operating_state_level1",
			"reg": 17,
			"level": 1, // level 1
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 11,
			"cathegory": 'Fan',
			"display_txt": level_configuration,
			"scene":1,
			"description": exhood_level_description,
			"help_txt": "",
		},
		"REG_18": {
			"id": "REG_18",
			"name": "operating_state_level2",
			"reg": 18,
			"type": "UINT",
			"level": 2, // level 2
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 22,
			"cathegory": 'Fan',
			"scene":2,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},
		"REG_19": {
			"id": "REG_19",
			"name": "operating_state_level3",
			"reg": 19,
			"level": 3,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 33,
			"cathegory": 'Fan',
			"scene":3,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},

		"REG_20": {
			"id": "REG_20",
			"name": "operating_state_level4",
			"reg": 20,
			"level": 4,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 44,
			"cathegory": 'Fan',
			"scene":4,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},

		"REG_21": {
			"id": "REG_21",
			"name": "operating_state_level5",
			"reg": 21,
			"level": 5,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 55,
			"cathegory": 'Fan',
			"scene":5,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},

		"REG_22": {
			"id": "REG_22",
			"name": "operating_state_level6",
			"reg": 22,
			"level": 6,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 66,
			"cathegory": 'Fan',
			"scene":6,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},

		"REG_23": {
			"id": "REG_23",
			"name": "operating_state_level6",
			"reg": 23,
			"level": 7,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 77,
			"cathegory": 'Fan',
			"scene":7,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},

		"REG_24": {
			"id": "REG_24",
			"name": "operating_state_level7",
			"reg": 24,
			"level": 8,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 88,
			"cathegory": 'Fan',
			"scene":8,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},


		"REG_25": {
			"id": "REG_25",
			"name": "operating_state_level9",
			"reg": 25,
			"level": 9,
			"type": "UINT",
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 100,
			"cathegory": 'Fan',
			"scene":9,
			"display_txt": level_configuration,
			"description": exhood_level_description,
			"help_txt": "",
		},


		// Configuration for Flap registers

		"REG_26": {
			"id": "REG_26",
			"name": "operating_state_off",
			"reg": 26,
			"type": "UINT",
			"level": 0,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 0,
			"cathegory": 'Flap',
			"scene":20,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_27": {
			"id": "REG_27",
			"name": "operating_state_level1",
			"reg": 27,
			"type": "UINT",
			"level": 1,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 11,
			"cathegory": 'Flap',
			"scene":21,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_28": {
			"id": "REG_28",
			"name": "operating_state_level2",
			"reg": 28,
			"type": "UINT",
			"level": 2,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 22,
			"cathegory": 'Flap',
			"scene":22,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_29": {
			"id": "REG_29",
			"name": "operating_state_level3",
			"reg": 29,
			"type": "UINT",
			"level": 3,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 33,
			"cathegory": 'Flap',
			"scene":23,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},

		"REG_30": {
			"id": "REG_30",
			"name": "operating_state_level4",
			"reg": 30,
			"type": "UINT",
			"level": 4,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 44,
			"cathegory": 'Flap',
			"scene":24,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_31": {
			"id": "REG_31",
			"name": "operating_state_level5",
			"reg": 31,
			"type": "UINT",
			"level": 5,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 55,
			"cathegory": 'Flap',
			"scene":25,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_32": {
			"id": "REG_32",
			"name": "operating_state_level6",
			"reg": 32,
			"type": "UINT",
			"level": 6,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 66,
			"cathegory": 'Flap',
			"scene":26,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_33": {
			"id": "REG_33",
			"name": "operating_state_level6=7",
			"reg": 33,
			"type": "UINT",
			"level": 7,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 77,
			"cathegory": 'Flap',
			"scene":27,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_34": {
			"id": "REG_34",
			"name": "operating_state_level8",
			"reg": 34,
			"type": "UINT",
			"level": 8,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 88,
			"cathegory": 'Flap',
			"scene":28,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
		"REG_35": {
			"id": "REG_35",
			"name": "operating_state_level9",
			"reg": 35,
			"type": "UINT",
			"level": 9,
			"min": 0,
			"max": 100,
			"step": 1,
			"unit": "%",
			"default": 100,
			"cathegory": 'Flap',
			"scene":29,
			"display_txt": level_configuration,
			"description": exhood_level_flap_description,
			"help_txt": "",
		},
	};

	//[scene,register,default]
	var Scene = [
		[0, 16, 0], //scene,reg,default_value
		[5, 17, 25],
		[17, 18, 50],
		[18, 19, 75],
		[19, 20, 100],
		//
		// [34,21,10],
		// [23,22,35],
		// [24,23,65],
		// [25,24,85],
		// [35,25,90],
		//
		// Include increment, decrement scenes
	];

	// for (var i in Scene){ // add scene configuration to registers array
	// 	var s = Scene[i];
	// 	var Reg="REG_"+s[1];
	// 	ExHoodRegConf[Reg]=sceneConf(s[0],s[1],s[2]);
	// }

	return ExHoodRegConf;

	//  return {
	// 	"pages":[
	// 	    { "name":"Airbox",
	// 	      "variables":AirboxRegConf,
	// 	    },
	// 	]
	// };
} // end ExHood get vars


function WCFans_GetVars() {

	var WCFansRegConf = {
		"VolumeRate": {
			"id": "REG_1",
			"name": "VolumeRate",
			"reg": 1,
			"type": "UINT",
			"min": 0,
			"max": 400,
			"step": 1,
			"unit": "m&sup3/h",
			"default": 60,
			"cathegory": 'V',
			"display_txt": "Volume rate",
			"description": "Please provide the ventilator's volume rate",
			"help_txt": "Please provide the ventilator volume rate",
		},
		"OnTime": {
			"id": "REG_2",
			"name": "OnTime",
			"reg": 2,
			"type": "UINT",
			"min": 0,
			"max": 600,
			"step": 1,
			"unit": "s",
			"default": 120,
			"cathegory": 'V',
			"display_txt": "Follow-up time",
			"description": "Please configure the ventilator's follow-up time",
			"help_txt": "",
		},

	};

	return WCFansRegConf;
} // end WCFans get vars®